﻿package 
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.geom.*;
	import flash.utils.Timer;
	import flash.events.*;
	import flash.text.*;
	import flash.filters.*;
	
	public class twEclair extends Sprite
	{
		private var destX,destY,Tx,Ty:Number;
		private var origineX,origineY : Number;
		private var originept:Point;
		private var segmentsMini:int;
		private var epaisseur:int;
		private var longueurSegments: Number;
		private var etape:Point;
		private var bzzz:Timer;
		private var angleGen:Number;
		private var conteneur:Sprite;
		private var anglemax:Number;
		private var tableauFiltres:Array;
		private var effetLueur:GlowFilter;
				
		public function twEclair(origine:Point,destination:Point,seg:int = 6,epais:int = 5, angle:Number = 80)
		{
			addEventListener(Event.REMOVED_FROM_STAGE, desactive);
			originept = origine;
			segmentsMini = seg;
			epaisseur = epais;
			anglemax = 20;
			origineX = origine.x;
			origineY = origine.y;
			destX = destination.x;
			destY = destination.y;
			longueurSegments = Point.distance(origine,destination)/segmentsMini;
			
			Tx = destination.x-origine.x;
			Ty = destination.y-origine.y;
			var anglegenRad:Number = Math.atan2(destination.y-origine.y,destination.x-origine.x);
			angleGen= anglegenRad*(180/Math.PI);
			conteneur = new Sprite;
			addChild(conteneur);
			
			tableauFiltres = new Array();
			effetLueur= new GlowFilter(0x0099FF,.7,10,10,5);
			tableauFiltres.push(effetLueur);
			conteneur.filters = tableauFiltres;
			
			bzzz= new Timer(70);
			bzzz.addEventListener("timer", traceSegments);
			bzzz.start();
		}
		
		public function traceSegments(evt:TimerEvent)
		{
			videconteneur();
			var AddTx:Number=0;
			var AddTy:Number=0;
			for (var i:int=segmentsMini;i>0;i--)
			{
				
				var segment:Shape = new Shape;
				segment.graphics.lineStyle(epaisseur,0x0099FF);
				segment.graphics.moveTo(origineX,origineY);
				var anglernd = Math.round(Math.random()*anglemax);
				var rnd = Math.random();
				if (rnd>0.5) anglernd*=-1;
				var angle = angleGen+anglernd;
				
				
				var anglerad:Number=2*Math.PI*(angle/360);
				etape = Point.polar(longueurSegments, anglerad);
				AddTx +=etape.x;
				AddTy +=etape.y;
				segment.graphics.lineTo(origineX+etape.x,origineY+etape.y);
				conteneur.addChild(segment);
				origineX += etape.x;
				origineY += etape.y;
			}
			segment.graphics.lineTo(destX,destY);
			
			origineX = originept.x;
			origineY = originept.y;
		}
		
		public function videconteneur()
		{
			while(conteneur.numChildren>0)
			{
				conteneur.removeChildAt(0);
			}
		}
		public function desactive(evt:Event)
		{
			bzzz.removeEventListener("timer", traceSegments);
			bzzz.stop();
			removeEventListener(Event.REMOVED_FROM_STAGE, desactive);
		}
	}
}